from .add import (
    add_block_fp,
    add_block_log,
    add_block_minifloat,
    add_integer,
    add_log,
    add_minifloat_denorm,
    add_minifloat_ieee,
    add_binary,
    add_ternary,
)
from .sub import (
    sub_block_fp,
    sub_block_log,
    sub_block_minifloat,
    sub_integer,
    sub_log,
    sub_minifloat_denorm,
    sub_minifloat_ieee,
    sub_binary,
    sub_ternary,
)
from .sub import (
    sub_block_fp,
    sub_block_log,
    sub_block_minifloat,
    sub_integer,
    sub_log,
    sub_minifloat_denorm,
    sub_minifloat_ieee,
    sub_binary,
)
from .matmul import (
    bmm_block_fp,
    bmm_block_log,
    bmm_block_minifloat,
    bmm_integer,
    bmm_log,
    bmm_minifloat_denorm,
    bmm_minifloat_ieee,
    bmm_binary,
    bmm_ternary,
    matmul_block_fp,
    matmul_block_log,
    matmul_block_minifloat,
    matmul_integer,
    matmul_log,
    matmul_minifloat_denorm,
    matmul_minifloat_ieee,
    matmul_binary,
    matmul_ternary,
)
from .mult import (
    mult_block_fp,
    mult_block_log,
    mult_block_minifloat,
    mult_integer,
    mult_log,
    mult_minifloat_denorm,
    mult_minifloat_ieee,
    mult_binary,
    mult_ternary,
)
from .relu import (
    relu_block_fp,
    relu_block_log,
    relu_block_minifloat,
    relu_integer,
    relu_log,
    relu_minifloat_denorm,
    relu_minifloat_ieee,
    relu_binary,
    relu_ternary,
)

quantized_func_map = {
    "add_block_minifloat": add_block_minifloat,
    "add_integer": add_integer,
    "add_fixed": add_integer,
    "add_log": add_log,
    "add_minifloat_ieee": add_minifloat_ieee,
    "add_minifloat_denorm": add_minifloat_denorm,
    "add_block_fp": add_block_fp,
    "add_block_log": add_block_log,
    "add_binary": add_binary,
    "add_ternary": add_ternary,
    "sub_block_minifloat": sub_block_minifloat,
    "sub_integer": sub_integer,
    "sub_fixed": sub_integer,
    "sub_log": sub_log,
    "sub_minifloat_ieee": sub_minifloat_ieee,
    "sub_minifloat_denorm": sub_minifloat_denorm,
    "sub_block_fp": sub_block_fp,
    "sub_block_log": sub_block_log,
    "sub_binary": sub_binary,
    "sub_ternary": sub_ternary,
    "mul_block_minifloat": mult_block_minifloat,
    "mul_integer": mult_integer,
    "mul_fixed": mult_integer,
    "mul_log": mult_log,
    "mul_minifloat_ieee": mult_minifloat_ieee,
    "mul_minifloat_denorm": mult_minifloat_denorm,
    "mul_block_fp": mult_block_fp,
    "mul_block_log": mult_block_log,
    "mul_binary": mult_binary,
    "mul_ternary": mult_ternary,
    "bmm_block_minifloat": bmm_block_minifloat,
    "bmm_integer": bmm_integer,
    "bmm_fixed": bmm_integer,
    "bmm_log": bmm_log,
    "bmm_minifloat_ieee": bmm_minifloat_ieee,
    "bmm_minifloat_denorm": bmm_minifloat_denorm,
    "bmm_block_fp": bmm_block_fp,
    "bmm_block_log": bmm_block_log,
    "bmm_binary": bmm_binary,
    "bmm_ternary": bmm_ternary,
    "matmul_block_minifloat": matmul_block_minifloat,
    "matmul_integer": matmul_integer,
    "matmul_fixed": matmul_integer,
    "matmul_log": matmul_log,
    "matmul_minifloat_ieee": matmul_minifloat_ieee,
    "matmul_minifloat_denorm": matmul_minifloat_denorm,
    "matmul_block_fp": matmul_block_fp,
    "matmul_block_log": matmul_block_log,
    "matmul_binary": matmul_binary,
    "matmul_ternary": matmul_ternary,
    "relu_block_minifloat": relu_block_minifloat,
    "relu_integer": relu_integer,
    "relu_fixed": relu_integer,
    "relu_log": relu_log,
    "relu_minifloat_ieee": relu_minifloat_ieee,
    "relu_minifloat_denorm": relu_minifloat_denorm,
    "relu_block_fp": relu_block_fp,
    "relu_block_log": relu_block_log,
    "relu_binary": relu_binary,
    "relu_ternary": relu_ternary,
}
